#ifndef PIV_UFO_BASE_H
#define PIV_UFO_BASE_H

#include <ufo/ufo.h>

struct piv_nodes;

struct piv_ufo_base
{
    UfoTaskGraph *graph;
    UfoArchGraph *arch;
    UfoResources *resources;
    UfoPluginManager *manager;
    UfoBaseScheduler *scheduler;
    GList *gpu_nodes;
    GError *error;
};


void piv_ufo_base_init(struct piv_ufo_base *piv_base);
void piv_ufo_base_unref(struct piv_ufo_base *piv_base);
void piv_ufo_base_connect(struct piv_ufo_base *piv_base, struct piv_nodes *piv,
                       unsigned scale, unsigned dump_ring_to_image,
                       UfoTaskNode* global_reader);

#endif /* PIV_UFO_BASE_H */

